## glava 1.6.3

=== Makefile ===
SHELL := /bin/bash

src = $(wildcard *.c)
obj = $(src:.c=.o)

# Build type parameter

ifeq ($(BUILD),debug)
    CFLAGS_BUILD = -O0 -ggdb -Wall -DGLAVA_DEBUG
    GLAD_GEN = c-debug
	STRIP_CMD = $(info Skipping `strip` for debug builds)
else
    CFLAGS_BUILD = -O2 -Wstringop-overflow=0
    GLAD_GEN = c
	STRIP_CMD = strip --strip-all glava
endif

# Detect OS if not specified (OSX, Linux, BSD are supported)

ifndef INSTALL
    UNAME_S := $(shell uname -s)
    ifeq ($(UNAME_S),Darwin)
        INSTALL = osx
    else
        INSTALL = unix
    endif
endif

ifndef EXECDIR
    EXECDIR = /usr/bin/
endif

# Install type parameter

ifeq ($(INSTALL),standalone)
    CFLAGS_INSTALL = -DGLAVA_STANDALONE
endif

ifeq ($(INSTALL),unix)
    CFLAGS_INSTALL = -DGLAVA_UNIX
    ifndef SHADERDIR
        ifdef XDG_CONFIG_DIRS
            SHADERDIR = /$(firstword $(subst :, ,$(XDG_CONFIG_DIRS)))/glava/
	    ifeq ($(wildcard $(SHADERDIR)/..),)
                SHADERDIR = /etc/xdg/glava/
            endif
        else
            SHADERDIR = /etc/xdg/glava/
        endif
    endif
endif

ifdef ENABLE_GLFW
    CFLAGS_GLFW = -DGLAVA_GLFW
    LDFLAGS_GLFW = -lglfw
endif

ifndef DISABLE_GLX
    CFLAGS_GLX = -DGLAVA_GLX
    LDFLAGS_GLX = -lXrender
endif

ifeq ($(INSTALL),osx)
    CFLAGS_INSTALL = -DGLAVA_OSX
    ifndef SHADERDIR
        SHADERDIR = /Library/glava
    endif
endif

LDFLAGS += $(ASAN) -lpulse -lpulse-simple -pthread $(LDFLAGS_GLFW) -ldl -lm -lX11 -lXext $(LDFLAGS_GLX)

PYTHON = python

GLAVA_VERSION = \"$(shell git describe --tags 2>/dev/null)\"
ifeq ($(GLAVA_VERSION),\"\")
    GLAVA_VERSION = \"unknown\"
endif

ifdef DESTDIR
	DESTDIR += /
endif

GLAD_INSTALL_DIR = glad
GLAD_SRCFILE = glad.c
GLAD_ARGS = --generator=$(GLAD_GEN) --extensions=GL_EXT_framebuffer_multisample,GL_EXT_texture_filter_anisotropic
CFLAGS_COMMON = -DGLAVA_VERSION="$(GLAVA_VERSION)" -DSHADER_INSTALL_PATH="\"$(SHADERDIR)\""
CFLAGS_USE = $(CFLAGS_COMMON) $(CFLAGS_GLX) $(CFLAGS_GLFW) $(CFLAGS_BUILD) $(CFLAGS_INSTALL) $(CFLAGS)

# Store relevant variables that may change depending on the environment or user input
STATE = $(BUILD),$(INSTALL),$(PREFIX),$(ENABLE_GLFW),$(DISABLE_GLX),$(PYTHON),$(CC),$(CFLAGS_USE)
# Only update the file if the contents changed, `make` just looks at the timestamp
$(shell if [[ ! -e build_state ]]; then touch build_state; fi)
$(shell if [ '$(STATE)' != "`cat build_state`" ]; then echo '$(STATE)' > build_state; fi)

all: glava

%.o: %.c build_state
	@$(CC) $(CFLAGS_USE) -o $@ -c $(firstword $<)
	@echo "CC $@"

glava: $(obj)
	@$(CC) -o glava $(obj) $(LDFLAGS)
	@echo "CC glava"
	$(STRIP_CMD)

.PHONY: glad
glad: build_state
	@cd $(GLAD_INSTALL_DIR) && $(PYTHON) -m glad $(GLAD_ARGS) --local-files --out-path=.
	@cp glad/*.h .
	@cp glad/glad.c .

# Empty build state goal, used to force some of the above rules to re-run if `build_state` was updated
build_state: ;

.PHONY: clean
clean:
	rm -f $(obj) glava glad.o build_state

EXECTARGET = $(shell readlink -m "$(DESTDIR)$(EXECDIR)/glava")
SHADERTARGET = $(shell readlink -m "$(DESTDIR)$(SHADERDIR)")

.PHONY: install
install:
	install -Dm755 glava $(EXECTARGET)
	install -d $(SHADERTARGET)
	cp -Rv shaders/* $(SHADERTARGET)

.PHONY: uninstall
uninstall:
	rm $(EXECTARGET)
	rm -rf $(SHADERTARGET)

=== debian/changelog ===
glava (1.6.3-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 14 Apr 2023 15:29:15 -0700

glava (1.6.3-1~jammy) jammy; urgency=medium

  * Upload for new Ubuntu

 -- Logix <logix@linuxuprising.com>  Thu, 29 Dec 2022 21:43:53 +0000
 

glava (1.6.3-1~impish) impish; urgency=medium

  * Prepare for the upcoming Ubuntu 21.10

 -- Logix <logix@linuxuprising.com>  Tue, 05 Oct 2021 10:12:29 +0000

glava (1.6.3-1~hirsute) hirsute; urgency=medium

  * Prepare for the upcoming Ubuntu 21.04

 -- Logix <logix@linuxuprising.com>  Fri, 02 Apr 2020 14:44:18 +0000

glava (1.6.3-1~groovy) groovy; urgency=medium

  * Prepare for the upcoming Ubuntu 20.10

 -- Logix <logix@linuxuprising.com>  Thu, 05 Mar 2020 15:00:39 +0000

glava (1.6.3-1~focal) focal; urgency=medium

  * Prepare for the upcoming Ubuntu 20.04

 -- Logix <logix@linuxuprising.com>  Thu, 05 Mar 2020 15:00:39 +0000

glava (1.6.3-1~eoan) eoan; urgency=medium

  * Prepare for the upcoming Ubuntu 19.10

 -- Logix <logix@linuxuprising.com>  Mon, 23 Sep 2019 10:21:19 +0000

glava (1.6.3-1~disco) disco; urgency=medium

  * New releases:
    1.6.1: 
          A problem with artifacting in circle has been fixed, see #107
          --stdin has been added, which binds simple GLSL datatypes to STDIN in shaders.
    1.6.2:
          Fixed a critical issue with --stdin that caused the alpha channel to be garbage 
          data
          Added a premultiply step to bars to allow for proper handling of the alpha 
          channel on "native" transparency. This is disabled by default, assign USE_ALPHA 
          to 1 in bars.glsl to enable.
    1.6.3: fixed a spelling error in utils/premutliply.frag that broke native transparency 
          in most modules

 -- Logix <logix@linuxuprising.com>  Wed, 13 Mar 2019 12:46:13 +0000

glava (1.6.0-1~bionic) bionic; urgency=medium

  * New release
  * Changelog: https://github.com/wacossusca34/glava/releases/tag/v1.6.0

 -- Logix <logix@linuxuprising.com>  Mon, 11 Mar 2019 10:38:45 +0000

glava (1.5.8-1~disco3) disco; urgency=medium

  * First release
  * GLFW is not enabled because I couldn't get it to build in Ubuntu
  * Depend on libglvnd-dev (for the actual package, not for building) -
    without this an error like this is shown: "Failed to load GLX functions 
    (libGL and libGLX do not exist!)"

 -- Logix <logix@linuxuprising.com>  Tue, 27 Nov 2018 16:33:24 +0200

=== debian/control ===
Source: glava
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Logix <logix@linuxuprising.com>
Standards-Version: 4.5.0
Build-Depends: debhelper-compat (= 12),
               libpulse-dev,
               libxcomposite-dev,
               libxext-dev,
               libxrender-dev,
#               python-all-dev
Homepage: https://github.com/wacossusca34/glava

Package: glava
Architecture: any
Depends: libglvnd-dev, ${misc:Depends}, ${shlibs:Depends}
Description: OpenGL audio spectrum visualizer
 GLava is an OpenGL audio spectrum visualizer.
 Its primary use case is for desktop windows or
 backgrounds.
